sock = require "sock"
bitser = require "bitser"
ser = require "ser"

if not love.filesystem.getInfo("client_config.txt") then
    config = {
        username = "Anonymous",
        adress = "localhost"
    }
    love.filesystem.write("client_config.txt", ser(config))
else
    local file = love.filesystem.load("client_config.txt")
    config = file()
end

me = {
    velocity = {x=0,y=0},
    position = {x=0,y=0},
    angle = 0
}

received = 0

local kb = love.keyboard

function love.load()
    love.window.setTitle("Quârz - Client")

    -- how often an update is sent out
    tickRate = 1/60
    tick = 0

    client = sock.newClient(config.adress, 22122)
    client:setSerialization(bitser.dumps, bitser.loads)

    -- store the client's index
    -- playerNumber is nil otherwise
    client:on("playerNum", function(data)
        playerNumber = data[1]
        me.position = data[2]

        client:send("info", config.username)
    end)

    players = {}

    -- receive info on where the players are located
    client:on("playerState", function(data)
        -- only accept updates for the other player
        if playerNumber then
            players = data
        end
        received = received + 1

        love.filesystem.write("client_players.lua", ser(data))
    end)

    client:connect()
end

function love.update(dt)
    client:update()

    if client:getState() == "connected" then
        tick = tick + dt

        -- take keyboard input for movements
        if kb.isDown("z") then me.velocity.y = -1
        elseif kb.isDown("s") then me.velocity.y = 1
        else me.velocity.y = 0 end
        if kb.isDown("q") then me.velocity.x = -1
        elseif kb.isDown("d") then me.velocity.x = 1
        else me.velocity.x = 0 end

        for k,_ in pairs(players) do
            if k ~= playerNumber then
                local pp, pv = players[k].position, players[k].velocity
                pp.x = pp.x + pv.x
                pp.y = pp.y + pv.y
            else
                me.position.x = me.position.x + me.velocity.x
                me.position.y = me.position.y + me.velocity.y

                me.angle = math.atan2(love.mouse.getY() - players[k].position.y, love.mouse.getX() - players[k].position.x)
            end
        end
    end

    if tick >= tickRate then
        tick = 0

        client:send("player", me)
    end
end

function love.mousereleased(x, y, button, isTouch)
    client:send("attack", {x, y})
end

function love.keypressed(key, scancode, isrepeat)
    if key == "escape" and client:isConnected() or client:isConnecting() then
        playerNumber = nil
        client:disconnect()
    elseif key == "space" and client:isDisconnected() then
        client:connect()
    end
end

function love.draw()
    Font = love.graphics.getFont()

    if client:getState() == "connected" then
        for k,_ in pairs(players) do
            if k ~= playerNumber then
                local player = players[k]
                love.graphics.setColor(255, 255, 255)
                love.graphics.print(player.username, player.position.x - Font:getWidth(player.username) / 2, player.position.y - Font:getHeight(player.username) * 1.5)
                love.graphics.setColor(255, 0, 0)
                love.graphics.rectangle('fill', player.position.x, player.position.y, 10, 10)
            else
                love.graphics.setColor(155, 155, 155)
                love.graphics.rectangle("fill", 5, 65, players[k].health * 25, 20)
                love.graphics.setColor(255, 0, 0)
                love.graphics.rectangle("fill", 5, 65, players[k].health * 25, 20)
                love.graphics.setColor(255, 255, 255)
                love.graphics.rectangle("fill", me.position.x, me.position.y, 10, 10)
            end
        end
    end

    love.graphics.setColor(255, 255, 255)
    love.graphics.print(client:getState().. " to IP adress: " ..config.adress, 5, 5)
    if playerNumber then
        love.graphics.print("Player " ..playerNumber.. " Angle: " ..math.deg(me.angle).. " Looking: " ..players[playerNumber].looking, 5, 25)
    else
        love.graphics.print("No player number assigned", 5, 25)
    end

    love.graphics.print("Data received: " ..received, 5, 45)
end
